--Basic Vars
x = 0
y = 0
sw = 0
sh = 0
dir = 6

--Load Level
dofile(level)

--Images
image = io.open("Pics.png", "rb")
picdata = image:read("*a")
image:close()
pics = Image.loadFromMemory(picdata)

--Image Buffer(s)
buffer = Image.createEmpty(504,504)
if table.getn(level[1]) > 21 then
	buffer2 = Image.createEmpty(504,504)
end

--Block Vars
bsize = pics:width()/6 --(should be 24 for full screen on lvl 1!)
block = false
block2 = false
blockgravity = 0

quit = false

oldpad = Controls.read()

--FPS
FPS_timer = Timer.new()

-- delay function. delays in milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end

--updates board with pics
function drawtoBoard(x,y)
	if x<=21 then
		buffer:blit(x*bsize-bsize,504-(y*bsize),pics,level[y][x]*bsize-bsize,0,24,24)
	end
	if x>21 then
		buffer2:blit(x*bsize-bsize-504,504-(y*bsize),pics,level[y][x]*bsize-bsize,0,24,24)
	end
end

--determines end of game
function lvlend()
	if level[playery][playerx+1] == 5 then x = playerx+1 y = playery
	elseif level[playery][playerx-1] == 5 then x = playerx-1 y = playery
	elseif level[playery+1][playerx] == 5 then x = playerx y = playery+1
	elseif level[playery-1][playerx] == 5 then x = playerx y = playery-1
	elseif level[playery+1][playerx+1] == 5 then x = playerx+1 y = playery+1
	elseif level[playery+1][playerx-1] == 5 then x = playerx-1 y = playery+1
	else x = 0 y = 0 end
end

--What to do if you beat the level!
function lbeat()
	if line + 1 == lnum then
		file = io.open("info.dat","w")
		line = line + 1
		file:write(line)
		file:close()
	end
	quit = true
end

--Pre-Renders Level, Max level size: 1008x504
for r = 1, table.getn(level) do
	if table.getn(level[1]) <= 21 then
		for l = 1, table.getn(level[1]) do
			buffer:blit(l*bsize-bsize,504-(r*bsize),pics,level[r][l]*bsize-bsize,0,24,24)
		end
	else
		for l = 1, 21 do
			buffer:blit(l*bsize-bsize,504-(r*bsize),pics,level[r][l]*bsize-bsize,0,24,24)
		end
		for q = 1, table.getn(level[1]) - 21 do
			buffer2:blit(q*bsize-bsize,504-(r*bsize),pics,level[r][q+21]*bsize-bsize,0,24,24)
		end
	end
end
	
while quit == false do
	lvlend()

	play_mp3()

	FPS_timer:reset()
	FPS_timer:start()

	screen:clear(Color.new(255,255,255))
	screen:blit(0-(sw*24),-232+(sh*24),buffer)
	if table.getn(level[1]) > 21 then
		screen:blit(504-(sw*24),-232+(sh*24),buffer2)
	end

	pad = Controls.read()

	oldy = playery
	oldx = playerx

	--Block Dude's Gravity
	level[oldy][oldx] = dir
	if level[playery-1][playerx] == 4 or level[playery-1][playerx] == 5 then playery = playery - 1 level[oldy][oldx] = 4
		if block == true and block2 == true then
			level[oldy+1][oldx] = 4
			level[playery+1][playerx] = 2
		end
	end
	--Basic Controls
	if oldpad ~= pad then
		if pad:right() then
			dir = 3
			if block == true then
				if level[playery+1][playerx + 1] ~= 2 and level[playery+1][playerx + 1] ~= 1 and level[playery][playerx + 1] ~= 2 and level[playery][playerx + 1] ~= 1 then
					playerx = playerx + 1 level[playery][playerx] = 3 level[oldy][oldx] = 4
					level[playery + 1][playerx] = 2 level[oldy+1][oldx] = 4
				end
			end
			if block == false and level[playery][playerx + 1] ~= 2 and level[playery][playerx + 1] ~= 1 then
				playerx = playerx + 1 level[playery][playerx] = 3 level[oldy][oldx] = 4
			end
		end
		if pad:left() then
			dir = 6
			if block == true then
				if level[playery+1][playerx - 1] ~= 2 and level[playery+1][playerx - 1] ~= 1 and level[playery][playerx - 1] ~= 2 and level[playery][playerx - 1] ~= 1 then
					playerx = playerx - 1 level[playery][playerx] = 6 level[oldy][oldx] = 4
					level[playery + 1][playerx] = 2 level[oldy+1][oldx] = 4
				end
			end
			if block == false and level[playery][playerx - 1] ~= 2 and level[playery][playerx - 1] ~= 1 then
				playerx = playerx - 1 level[playery][playerx] = 6 level[oldy][oldx] = 4
			end
		end
		--Pick up block
		if pad:down() and block == false then
			if level[playery][playerx - 1] == 2 then
				if dir == 6 then
					if level[playery+1][playerx - 1] == 4 and level[playery+1][playerx] == 4 then
						level[playery][playerx - 1] = 4
						level[playery+1][playerx] = 2
						block = true
					end
				end
			end
			if level[playery][playerx + 1] == 2 then
				if dir == 3 then
					if level[playery+1][playerx + 1] == 4 and level[playery+1][playerx] == 4 then
						level[playery][playerx + 1] = 4
						level[playery+1][playerx] = 2
						block = true
					end
				end
			end
		end
		--Put block down
		if pad:down() and block == true and block2 == true then
			if dir == 6 then
				if level[playery][playerx-1] == 2 or level[playery][playerx-1] == 1 then
					if level[playery+1][playerx-1] == 4 then
						level[playery+1][playerx-1] = 2
						level[playery+1][playerx] = 4
						drawtoBoard(playerx-1,playery+1)
						block = false
						block2 = false
					end
				else
				repeat blockgravity = blockgravity + 1 until
					level[playery-blockgravity][playerx-1] == 1 or level[playery-blockgravity][playerx-1] == 2
					if level[playery-blockgravity+1][playerx-1] ~= 1 then
						level[playery-blockgravity+1][playerx-1] = 2
						level[playery+1][playerx] = 4
						drawtoBoard(playerx-1,playery-blockgravity+1)
						blockgravity = 0
						block = false
						block2 = false
					else
						blockgravity = 0
					end
				end
			end
			if dir == 3 then
				if level[playery][playerx+1] == 2 or level[playery][playerx+1] == 1 then
					if level[playery+1][playerx+1] == 4 then
						level[playery+1][playerx+1] = 2
						level[playery+1][playerx] = 4
						drawtoBoard(playerx+1,playery+1)
						block = false
						block2 = false
					end
				else
				repeat blockgravity = blockgravity + 1 until
					level[playery-blockgravity][playerx+1] == 1 or level[playery-blockgravity][playerx+1] == 2
					if level[playery-blockgravity+1][playerx+1] ~= 1 then
						level[playery-blockgravity+1][playerx+1] = 2
						level[playery+1][playerx] = 4
						drawtoBoard(playerx+1,playery-blockgravity+1)
						blockgravity = 0
						block = false
						block2 = false
					else
						blockgravity = 0
					end
				end
			end	
		end
		if pad:up() and not pad:left() and not pad:right() then
			if level[playery][playerx - 1] == 2 or level[playery][playerx - 1] == 1 then
				if dir == 6 then
					if block == true and level[playery+1][playerx - 1] ~= 2 and level[playery+1][playerx - 1] ~= 1 and level[playery+2][playerx - 1] ~= 2 and level[playery+2][playerx - 1] ~= 1 then
						playery = playery + 1 playerx = playerx - 1 level[oldy][oldx] = 4
						level[playery + 1][playerx] = 2 level[oldy+1][oldx] = 4
					end
					if block == false and level[playery+1][playerx - 1] ~= 2 and level[playery+1][playerx - 1] ~= 1 then
						playery = playery + 1 playerx = playerx - 1 level[oldy][oldx] = 4
					end
				end
			end
			if level[playery][playerx + 1] == 2 or level[playery][playerx + 1] == 1 then
				if dir == 3 then
					if block == true and level[playery+1][playerx + 1] ~= 2 and level[playery+1][playerx + 1] ~= 1 and level[playery+2][playerx + 1] ~= 2 and level[playery+2][playerx + 1] ~= 1 then
						playery = playery + 1 playerx = playerx + 1 level[oldy][oldx] = 4
						level[playery + 1][playerx] = 2 level[oldy+1][oldx] = 4
					end
					if block == false and level[playery+1][playerx + 1] ~= 2 and level[playery+1][playerx + 1] ~= 1 then
						playery = playery + 1 playerx = playerx + 1 level[oldy][oldx] = 4
					end
				end
			end
		end
	end
	
	--Use Manual Scrolling
	if oldpad ~= pad then
		if pad:circle() then sw = sw + 1 end
		if pad:square() then sw = sw - 1 end
		if pad:triangle() then sh = sh + 1 end
		if pad:cross() then sh = sh - 1 end
	end
	
	--Cant Move Screen Past...
	if sw <= 0 then sw = 0 end
	if sh <= 0 then sh = 0 end
	if table.getn(level[1]) > 20 then
		if sw >= table.getn(level[1]) - 20 then sw = table.getn(level[1]) - 20 end
	else sw = 0 end
	if table.getn(level) > 11 then
		if sh >= table.getn(level) - 11 then sh = table.getn(level) - 11 end
	else sh = 0 end
	
	--ID3 Display with nice scrolly effect
	if scroll > (string.len(mp3info)*-8) - 1 then
		scroll = scroll - .5
	end
	if scroll < (string.len(mp3info)*-8) then scroll = 480 end
	screen:blit(scroll,1,sbuffer)
	
	--FPS
	screen:print(1,10,"FPS: "..math.floor(1000/FPS_timer:time()))
	
	--Draws certain pieces to the board at all times
	drawtoBoard(playerx,playery)
	drawtoBoard(playerx,playery+1)
	drawtoBoard(playerx-1,playery)
	drawtoBoard(playerx,playery-1)
	drawtoBoard(playerx+1,playery)
	drawtoBoard(oldx,oldy)
	drawtoBoard(oldx,oldy+1)
	
	--Quits Game
	if pad:start() then buffer = nil buffer2 = nil collectgarbage() quit = true end
	if pad:select() then screen:save("ms0:/PSP/PHOTO/Block Dude Screen Shot.png") end
	if playerx == x and playery == y then buffer = nil buffer2 = nil collectgarbage() lbeat() end
	
	--That Flip Screen stuff
	screen.flip()
	screen.waitVblankStart()
	oldpad = pad
	if block == true then block2 = true end
end
