--Images
menu = Image.load("menu.png")
pics = Image.load("Pics.png")

--Options
opt = 1
oldpad = Controls.read()

--Save Game Stuff
file = io.open("info.dat","r")
line = tonumber(file:read())
file:close()
lnum = 1

--MP3
dofile("mp3lib.lua")
init_mp3()
scroll = 480

--Displays Messages in Bottom left
message = {
	"Pick a Level to Play",
	"Over-writes Game Save",
	"Exit"
}

function play()
	screen:print(210, 100, "Level " .. lnum)
	if oldpad ~= pad then
		if pad:left() and lnum > 1 then lnum = lnum - 1 end
		if pad:right() then if lnum < line + 1 and lnum < 11 then lnum = lnum + 1 end end
		if pad:cross() then
			if lnum < 10 then 
				level = "./Levels/level0" .. lnum .. ".lua"
			else
				level = "./Levels/level" ..  lnum .. ".lua"
			end
			dofile("game.lua")
		end
	end
end

function new()
	file2 = io.open("info.dat","w")
	file2:write("0")
	file2:close()
	line = 0
	lnum = 1
end

while true do
	pad = Controls.read()
	play_mp3()
	screen:blit(0,0,menu)
	if opt == 1 then play() end
	if oldpad ~= pad then
		if pad:down() and opt < 3 then opt = opt + 1 end
		if pad:up() and opt > 1 then opt = opt - 1 end
		if pad:cross() then
			if opt == 2 then new() end
			if opt == 3 then Mp3.stop() System.Quit() break end
		end
	end
	screen:blit(125,((2.75 + opt) * 24) + opt,pics,3*24-24,0,24,24)
	screen:print(10,238,message[opt])
	screen.flip()
	screen.waitVblankStart()
	oldpad = pad
end
